#!/usr/bin/perl

##############################################################################
# viruslog.pl (C) J. Fiebig <superlehrer@gmx.de>                             #
# This script is free software. You may redistribute and/or modify  it under #
# the terms and conditions of the GNU General Public License, Version 2      #
#                                                                            #
# There is NO WARRANTY on anything!                                          #
# 									     #
# Das Script beruht auf dem Quelltext des Scriptes smbstatus2html.pl für     #
# Arktur 3 von Rene van Bevern						     #
##############################################################################
# Das Script setzt eine Installation von Clamav voraus.                      #
# Dabei sollten die clamav signaturen in /opt/bdc/ liegen,                   #
# Der Aufruf von clamav muss die Option --stdout und eine Umleitung enthalten#
# z.B.:  clamscan -i -r --stdout /home > /var/log/clamscan.log               #                       #
# in der crontab.                                                            #
# die Datei clamscan.log muss für andere auf lesen gesetzt werden            #
# Ein Start vom Script aus ist nicht sinnvoll, da der Scan lange dauern kann #
##############################################################################
# Version 1.0 mit Anpassungen an das Layout und den vorinstallierten 
# Virenscanner von Arktur 4 (ab Version 4 beta 44)
#
# Version 1.1 mit Anpassungen an die neuen Meldungen von clamav 0.9
# und Arktur 4 RC 5

# Hier wird konfiguriert über welche Datei der Datenaustausch gemacht wird

$log_file = "/var/log/clamscan.log";
$date = `/bin/date \"+%T %e.%m.%Y\"`;

open LOG_OUTPUT, '<'.$log_file;
@log_output = <LOG_OUTPUT>;
close (LOG_OUTPUT);



$update_file = "/tmp/clamav.update";
system "ls -l -t --time-style=+%d.%m.%Y%k:%M /var/lib/clamav/*.* > /tmp/clamav.update";
open UPDATE_OUTPUT, '<'.$update_file;
@update_output = <UPDATE_OUTPUT>;
close (UPDATE_OUTPUT);


$date_file = "/tmp/clamav.date";
system "ls -l --time-style=+%d.%t%m.%t%Y%tgegen%t%k:%M /var/log/clamscan.log > /tmp/clamav.date";
open DATE_OUTPUT, '<'.$date_file;
@date_output = <DATE_OUTPUT>;
close (DATE_OUTPUT);

print "Content-type: text/html\n\n";
print "<HTML>";
print "<head> <link rel=\"stylesheet\" href=\"style.css\">";
print "</head> ";

# print "<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\"\
#BACKGROUND=\"/online/whttxtr2.jpg\"><FONT SIZE=\"-1\">Datum: $date</FONT><BR><BR>\n";

print "<body background=\"whttxtr2.jpg\">";

print "<center><h2 class=\"title\"><b>Auswertung der Virenpr&uuml;fung</b></h2></center><br>";


foreach $line (@date_output)
{
	@fields = split(/ +/,$line);
	print "<FONT SIZE=\"+2\">Ergebnisse der letzten Virensuche vom $fields[5]";
	if ($fields[6]!~/var/) { print  $fields[6];}
	print " Uhr:</FONT><BR>"; 
	eo_foreach:
}

$Anzahl=0;
foreach $line (@update_output)
{
	if ($Anzahl==0)
	{@fields = split(/ +/,$line);
	 print "<FONT SIZE=\"-1\">Virensignaturen vom $fields[5] - ";
	if ($fields[6]!~/var/) { print  $fields[6];}
	print " Uhr:</FONT><BR>"; 
	 $Anzahl=1; 
	} 
	eo_foreach:
}


$Anzahl=0;
$Anzahll=0;
foreach $line (@log_output)
{
	$Anzahll=$Anzahll+1;
	if($line=~/FOUND/) {$Anzahl=$Anzahl+1; goto eo_foreach;}
	
	eo_foreach:
}

print "<FONT SIZE=\"+1\"> <STRONG>";
if ($Anzahll==0) { print "Keine Logdatei vorhanden!" }
else
{
if ($Anzahl==0) {print "<FONT SIZE=\"+2\" style=\"color: rgb(51, 205, 0);\">\
                 Ihr System ist virenfrei!<BR></FONT></FONT><BR>\
		 Weitere Meldungen:<FONT SIZE=\"+1\"><BR>"} else
{
print "<FONT style=\"color: rgb(0, 0, 255);\">";
if ($Anzahl==1) {print "Es wurde ein Virus gefunden!<BR><BR>";} else 
{print "Es wurden $Anzahl Viren gefunden!<BR><BR>";}
print "</FONT>";
}
}
print "</STRONG></FONT>";

foreach $line (@log_output)
{
	if($line=~/^\s*$/) {goto eo_foreach;}
	if($line=~/Scan started:/) {goto eo_foreach;}	
	if($line=~/Empty file/) {goto eo_foreach;}		
	if($line=~/----------------------------------/) {goto eo_foreach;}			
#	if($line=~/Removed/) {print "$line<BR>"; goto eo_foreach;}	
	if($line=~/moved/) {print "$line<BR>"; goto eo_foreach;}
	if($line=~/FOUND/) {print "<FONT SIZE=\"+1\" style=\"color: rgb(255, 0, 0);\">$line</FONT><BR>"; goto eo_foreach;}
	if($line=~/SCAN SUMMARY/) {print "<br><br>Zusammenfassung:<br>"; goto eo_foreach;}	
	print "$line &nbsp;&nbsp;";
	eo_foreach:
}
 print "<BR>";


print "<br><br><FONT SIZE=\"-1\">\
clamavlog.cgi - Version 1.1 (C) Februar 2007,<BR>\
f&uuml;r Arktur 4 von <A HREF=\"mailto:JFiebig\@chefmail.de\">J. Fiebig</A> vom\
<A HREF=\"http://www.Erzgebirgskolleg.de\">Erzgebirgskolleg Breitenbrunn</A>.\
</FONT></BODY></HTML>";

system "rm -f /tmp/clamav.date";
system "rm -f /tmp/clamav.update";

exit 1;
